ExclusiveArch: i386 ia64 alpha

%define kdedir /usr/lib/kde2-compat

%define kde_major_version 2
%define pkg kdelibs
%define is_release 1
%define beta %{nil}
#define cups cups
%define cups %{nil}
%define rel 9
%define debug 0
%define DATE 20020109
Version: 2.2.2
%define ver %{version}%{beta}
Summary: Compatibility libraries for the K Desktop Environment (KDE) 2.2.x.
%if %{is_release}
Source: ftp://ftp.kde.org/pub/kde/stable/%{version}/distribution/tar/generic/source/%{pkg}-%{ver}.tar.bz2
%else
Source: cvs://cvs.kde.org/%{pkg}-%{DATE}.tar.bz2
%endif
Patch1: kdelibs-2.0-final.patch
Patch2: kdelibs-2.0-nodebug.patch
Patch3: klauncher-escape.patch
Patch4: kdelibs-20010205-Japanese.patch
Patch5: kdelibs-2.2.1-cookies.patch
Patch6: kdelibs-2.1-noxs.patch
Patch7: kdelibs-2.1.1-debug.patch
Patch8: kdelibs-2.1.1-cookieperms.patch
Patch10: kdelibs-2.2-ssl.patch
Patch11: kdelibs-2.1.1-path.patch
Patch14: khtml-onChange.patch
Patch15: kdelibs-2.2.1-glib.patch
Patch16: kdelibs-2.2.2-incl.patch
# Japanese patches
Patch100: http://www.kde.gr.jp/patch/kdelibs-2.2beta1-keditcl1-20010706.diff
Patch101: http://www.kde.gr.jp/patch/kdelibs-2.2beta1-khtml-autoencode-ja-20010708.diff
Name: kde2-compat
Prefix: %{kdedir}
#Prefix: %{_prefix}
Requires: qt2 >= 2.3.1 openssl
BuildRequires: qt2-devel >= 2.3.1
Obsoletes: %{pkg}2 
BuildPrereq: flex >= 2.5.4a-13 kdoc >= %{version} libxslt-devel >= 1.0.7
BuildPrereq: sgml-common openjade jadetex docbook-dtd31-sgml docbook-style-dsssl perl-SGMLSpm docbook-utils pcre-devel zlib-devel openssl-devel libxslt-devel
BuildPrereq: compat-gcc = 7.3 compat-gcc-c++ = 7.3
%if "%{cups}" != ""
BuildRequires: cups-devel
%endif
Epoch: 6
%if %{is_release}
%if "%{beta}" != ""
Release: 1.%{beta}.%{rel}
%else
Release: %{rel}
%endif
%else
Release: 1.cvs%{DATE}.%{rel}
%endif
Group: System Environment/Libraries
License: LGPL
BuildRoot: %{_tmppath}/%{pkg}-buildroot
Prereq: fileutils
Obsoletes: kdesupport

%description
The K Desktop Environment (KDE) is a GUI desktop for the X Window
System. The kdelibs package contains a variety of libraries used by
KDE, including: kdecore, the KDE core library; kdeui, a user interface
library; kfm, the file manager; khtmlw, HTML widgets; kfile, for file
access; kspell, the spelling checker; jscript, for javascript; kab,
the addressbook; kimgio, for image manipulation; and arts, for sound,
mixing, and animation.

%prep
rm -rf $RPM_BUILD_ROOT

%if %{is_release}
%setup -q -n %{pkg}-%{ver}
%else
%setup -q -n %{pkg}
%endif

%patch1 -p1 -b .final
%if %{debug} == 0
%patch2 -p1 -b .nodebug
%patch7 -p1 -b .debug
%endif
%patch3 -p1 -b .esc
%patch4 -p1 -b .jp
%patch5 -p1 -b .cookieesc
%patch6 -p1 -b .noxs
%patch8 -p1 -b .sec
%patch11 -p1 -b .path
%patch14 -p1 -b .onChange
%patch15 -p1 -b .glib
%patch10 -p1 -b .ssl

%patch100 -p1 -b .jp1
# # # patch101 -p1 -b .jp2

# Make the version number say what it should say
perl -pi -e 's,#define KDE_VERSION_STRING .*,#define KDE_VERSION_STRING "%{version}-%{release}",g' kdecore/kapp.h

# Get the correct auto* tools
ln -s /usr/bin/automake-1.5 automake
ln -s /usr/bin/aclocal-1.5 aclocal
export PATH=`pwd`:$PATH

make -f Makefile.cvs

# Fix some broken autogenerated files
cd arts/mcopidl
flex -oscanner.cc scanner.ll
cd ../../dcop/dcopidl
flex -oscanner.cc scanner.ll
cd ../..

%build
QTDIR=/usr/lib/qt2
export QTDIR

if [ -x /usr/bin/getconf ]; then
  CPUS=`getconf _NPROCESSORS_ONLN`
fi
if test "x$CPUS" = "x" -o "x$CPUS" = "x0"; then
  CPUS=1
fi

%if %{debug}
export FLAGS="-O0 -DDEBUG=1"
%else
export FLAGS="-O3 -DNDEBUG -UDEBUG -DNODEBUG -UDEBUG_ASYNC_TRANSFER -UVPORT_DEBUG -UDEBUG_IO -UDEBUG_MESSAGES -UDEBUG_AUTH -UDEBUG_CONNECTION_DATA -DYYDEBUG=0 -UNETWMDEBUG -UCSS_DEBUG -UCSS_STYLESHEET_DEBUG -USPEED_DEBUG -UKJS_DEBUGGER -UFORMS_DEBUG -UDEBUG_LAYOUT -UDEBUG_DRAW_BORDER -UPARSER_DEBUG -UDECODE_DEBUG -UCACHE_DEBUG -UBUFFER_DEBUG -UJPEG_DEBUG -UDEBUG_LINEBREAKS -UBOX_DEBUG -UTABLE_DEBUG -UYYERROR_VERBOSE -UKJS_DEBUG_MEM -UMIDIOUTDEBUG -UGENERAL_DEBUG_MESSAGES"
%endif

export FLAGS="$RPM_OPT_FLAGS -fno-rtti -fno-exceptions -fno-check-new $FLAGS -D_GNU_SOURCE"
export FLAGS="-I/usr/kerberos/include $FLAGS"

VERSION=`cat /etc/redhat-release |awk '{ print $5; }'`
autoconf
export CC="gcc296"
export CXX="g++296"
CXXFLAGS="$FLAGS" CFLAGS="$FLAGS" ./configure \
	--prefix=%{prefix} \
%if "%{cups}" != ""
	--enable-cups \
%endif
	--enable-mitshm \
	--includedir=%{prefix}/include/kde \
%if "%{debug}" == "0"
	--disable-debug \
	--without-debug \
	--enable-final \
%endif
	--with-distribution="Red Hat Linux $VERSION"
# Workaround for broken 7.3 package with insufficient permissions
# of /usr/lib/kde2-compat/
#%patch16 -p1 -b .incl
for file in `find . -name Makefile`; do
   perl -pi -e "s,^kde_includes = ,kde_includes = #,g" $file
   perl -pi -e "s,^KDE_INCLUDES = ,KDE_INCLUDES = #,g" $file
done

make # %{?_smp_mflags}

%install
export QTDIR=/usr/lib/qt2

export CC="gcc296"
export CXX="g++296"


export DESTDIR=$RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install-strip

chmod a+x $RPM_BUILD_ROOT%{prefix}/lib/*

# Make symlinks relative
pushd $RPM_BUILD_ROOT%{prefix}/share/doc/HTML/en
for i in *; do
	if [ -d $i -a -L $i/common ]; then
		rm -f $i/common
		ln -sf ../common $i
	fi
done
popd

mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-devel-%{version}
install -m 644 KDE2PORTING.html $RPM_BUILD_ROOT%{_docdir}/%{name}-devel-%{version}


mkdir -p $RPM_BUILD_ROOT/usr/lib
pushd $RPM_BUILD_ROOT/usr/lib
for i in kde2-compat/lib/*.so.*; do
  ln -nfs $i .
done
popd

mkdir -p $RPM_BUILD_ROOT/usr/include
pushd $RPM_BUILD_ROOT/usr/include
ln -nfs ../lib/kde2-compat/include kde2
popd

perl -pi -e "s,^libdir='/usr/lib',libdir='/usr/lib/kde2-compat/lib',g" $RPM_BUILD_ROOT/usr/lib/kde2-compat/lib/*.la

rm -f $RPM_BUILD_ROOT/usr/lib/libartsc.so.0
rm -f $RPM_BUILD_ROOT/usr/lib/libartsc.so.0.0.0
rm -f $RPM_BUILD_ROOT/usr/lib/libartscbackend.so.0
rm -f $RPM_BUILD_ROOT/usr/lib/libartscbackend.so.0.0.0
rm -f $RPM_BUILD_ROOT/usr/lib/libartsdsp.so.0
rm -f $RPM_BUILD_ROOT/usr/lib/libartsdsp.so.0.0.0
rm -f $RPM_BUILD_ROOT/usr/lib/libartsdsp_st.so.0
rm -f $RPM_BUILD_ROOT/usr/lib/libartsdsp_st.so.0.0.0
rm -f $RPM_BUILD_ROOT/usr/lib/libartswavplayobject.so.0
rm -f $RPM_BUILD_ROOT/usr/lib/libartswavplayobject.so.0.0.0

rm -f $RPM_BUILD_ROOT/usr/lib/libkjava.so.1
rm -f $RPM_BUILD_ROOT/usr/lib/libkjava.so.1.0.0
rm -f $RPM_BUILD_ROOT/usr/lib/libkjs.so.1
rm -f $RPM_BUILD_ROOT/usr/lib/libkjs.so.1.0.0
rm -f $RPM_BUILD_ROOT/usr/lib/libkmid.so.0
rm -f $RPM_BUILD_ROOT/usr/lib/libkmid.so.0.0.95
rm -f $RPM_BUILD_ROOT/usr/lib/libktexteditor.so.0
rm -f $RPM_BUILD_ROOT/usr/lib/libktexteditor.so.0.0.0

rm -rf $RPM_BUILD_ROOT%{prefix}/include/kde $RPM_BUILD_ROOT%{prefix}/bin/{artsc-config,mcopidl}
rm -rf $RPM_BUILD_ROOT/usr/share/doc/kde2-compat-devel-%{version}/KDE2PORTING.html
rm -f $RPM_BUILD_ROOT%{prefix}/lib/mega.*
%if "%{cups}" != ""
%else
rm -f $RPM_BUILD_ROOT%{prefix}/bin/cups*
rm -f $RPM_BUILD_ROOT%{prefix}/lib/libcups*
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%pre
chmod -R u+rwX /usr/lib/kde2-compat >/dev/null 2>&1 || :

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig


%files
%defattr(-,root,root)
/usr/lib/*so.*
%%attr(0755,root,root) %dir %{prefix}
%%attr(0755,root,root) %dir %{prefix}/bin
%%attr(0755,root,root) %dir %{prefix}/lib
%%attr(0755,root,root) %dir %{prefix}/share
%{prefix}/bin/dcop*
%{prefix}/bin/kbuildsycoca
%{prefix}/bin/preparetips
%{prefix}/bin/imagetops
%{prefix}/bin/kcookiejar
%{prefix}/bin/kshell
%{prefix}/bin/kwrapper
%{prefix}/bin/kde*
%{prefix}/bin/kdont*
%{prefix}/bin/kio*
%{prefix}/bin/kpac_*
%{prefix}/bin/kconf_*
%{prefix}/bin/klauncher
%{prefix}/bin/kmailservice
%{prefix}/bin/lnusertemp
%{prefix}/bin/settheme
%{prefix}/bin/ksendbugmail
%{prefix}/bin/make*
%{prefix}/bin/meinproc
%{prefix}/bin/xml*
%{prefix}/bin/kdb2html
%{prefix}/bin/checkXML
%{prefix}/lib/*style.*
%{prefix}/lib/dcop*
%{prefix}/lib/kconf*
%{prefix}/lib/kbuildsycoca*
%{prefix}/lib/kcookiejar*
%{prefix}/lib/kded*
%dir %{prefix}/lib/kde2
%{prefix}/lib/kde2/*
%{prefix}/lib/kio*
%{prefix}/lib/klauncher*
%{prefix}/lib/libDCOP*
%{prefix}/lib/libkab.*
%{prefix}/lib/libkde*
%{prefix}/lib/libkfile.*
%{prefix}/lib/libkhtml*.*
%{prefix}/lib/libkio.*
%{prefix}/lib/libkjava.*
%{prefix}/lib/libkjs.*
%{prefix}/lib/libkparts.*
%{prefix}/lib/libkscreensaver.*
%{prefix}/lib/libkspell.*
%{prefix}/lib/libkssl.*
%{prefix}/lib/libksycoca.*
%{prefix}/lib/libktexteditor.*
%dir %{prefix}/share/apps
%{prefix}/share/apps/*
%dir %{prefix}/share/config
%config(noreplace) %{prefix}/share/config/*
%{prefix}/share/icons/*
%dir %{prefix}/share/mimelnk
%{prefix}/share/mimelnk/*
%dir %{prefix}/share/services
%{prefix}/share/services/*.kimgio
%{prefix}/share/services/*.protocol
%{prefix}/share/services/*.desktop
%dir %{prefix}/share/services/kded
%{prefix}/share/services/kded/*
%dir %{prefix}/share/servicetypes
%{prefix}/share/servicetypes/*
%doc %{prefix}/share/doc/HTML/*
%if "%{cups}" != ""
%{prefix}/bin/cups*
%{prefix}/lib/libcups*
%endif

%{prefix}/bin/knotify
%{prefix}/bin/artsmessage
%{prefix}/lib/libkmid.*
%{prefix}/lib/libqtmcop.*
%{prefix}/lib/knotify*
%{prefix}/lib/libx11globalcomm.*
%{prefix}/lib/libartskde*

%dir %{prefix}/lib/mcop
%dir %{prefix}/lib/mcop/Arts
%{prefix}/lib/mcop/Arts/*
%{prefix}/lib/mcop/*.mcopclass
%{prefix}/lib/mcop/*.mcoptype
%{prefix}/bin/artscat
%{prefix}/bin/artsd*
%{prefix}/bin/artsp*
%{prefix}/bin/artss*
%{prefix}/bin/artsw*
%{prefix}/lib/libartsc*.la
%{prefix}/lib/libartsc*.so*
%{prefix}/lib/libartsdsp*.la
%{prefix}/lib/libartsdsp*.so*
%{prefix}/lib/libartsflow*.la
%{prefix}/lib/libartsflow*.so*
%{prefix}/lib/libartswav*.la
%{prefix}/lib/libartswav*.so*
%{prefix}/lib/libmcop.*
%{prefix}/lib/libmcop_mt.*
%{prefix}/lib/libsound*
%{prefix}/lib/libkmedia*


%changelog
* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Mon Dec 16 2002 Elliot Lee <sopwith@redhat.com>
- Rebuild

* Wed Nov 20 2002 Florian La Roche <Florian.LaRoche@redhat.de>
- do not build on mainfame

* Wed Jul 24 2002 Bill Nottingham <notting@redhat.com> 2.2.2-7
- %%pre hack to handle upgrades from broken permissions
- fix %%pre hack

* Fri Jul 12 2002 Karsten Hopp <karsten@redhat.de>
- fix directory permissions (#64668)
- added workaround for #67003 (can't rebuild when package with
  wrong permissions (#64668) has been installed.

* Thu Jun 06 2002 Than Ngo <than@redhat.com> 2.2.2-4
- requires correct version of compat-gcc

* Wed May 29 2002 Bernhard Rosenkraenzer <bero@redhat.com> 2.2.2-3
- Make sure gcc 2.96 is used

* Sat Apr 13 2002 Harald Hoyer <harald@redhat.de> 2.2.2-2
- correct permissions of the directories

* Wed Mar 27 2002 Harald Hoyer <harald@redhat.de>
- first version of kde2-compat

